"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.createAutocaptureMethods = void 0;
var sanitize_1 = require("./sanitize");
var pageviews_1 = require("./pageviews");
var createAutocaptureMethods = function (handleInvocation, logger, defaultSource, resolvePageviewKey) {
    if (defaultSource === void 0) { defaultSource = null; }
    var logSource = defaultSource === null || defaultSource === void 0 ? void 0 : defaultSource.name;
    var sanitizedDefaultSource = (0, sanitize_1.sanitizeSourceInfo)(defaultSource, logger, logSource);
    return {
        trackInteraction: function (interaction, nodes, callbackName, timestamp, sourceInfo, sourceProperties, pageview) {
            return __awaiter(this, void 0, void 0, function () {
                var sanitizedInteraction, sanitizedNodes, sanitizedSourceInfo, javascriptEpochTimestamp, sanitizedSourceProperties, pageviewKey, args;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            timestamp !== null && timestamp !== void 0 ? timestamp : (timestamp = new Date());
                            sanitizedInteraction = (0, sanitize_1.sanitizeInteractionType)(interaction, logger, logSource);
                            sanitizedNodes = (0, sanitize_1.sanitizeInteractionNodes)(nodes, logger, logSource);
                            sanitizedSourceInfo = (0, sanitize_1.sanitizeSourceInfo)(sourceInfo, logger, logSource) || sanitizedDefaultSource;
                            javascriptEpochTimestamp = (0, sanitize_1.sanitizeTimestamp)(timestamp, logger, logSource);
                            sanitizedSourceProperties = (0, sanitize_1.sanitizeProperties)(sourceProperties, logger, logSource);
                            return [4 /*yield*/, resolvePageviewKey(pageview, sourceInfo, timestamp)];
                        case 1:
                            pageviewKey = _a.sent();
                            if (!sanitizedInteraction || !sanitizedNodes) {
                                logger.warn('trackInteraction failed because interaction or nodes were invalid.', logSource);
                                return [2 /*return*/];
                            }
                            args = {
                                interaction: sanitizedInteraction,
                                nodes: sanitizedNodes,
                            };
                            if ((0, sanitize_1.isNonEmptyString)(callbackName)) {
                                args.callbackName = callbackName;
                            }
                            if (javascriptEpochTimestamp) {
                                args.javascriptEpochTimestamp = javascriptEpochTimestamp;
                            }
                            if (sanitizedSourceInfo) {
                                args.sourceLibrary = sanitizedSourceInfo;
                            }
                            if (sanitizedSourceProperties) {
                                args.sourceProperties = sanitizedSourceProperties;
                            }
                            if (pageviewKey) {
                                args.pageviewKey = pageviewKey;
                            }
                            handleInvocation('trackInteraction', args);
                            return [2 /*return*/];
                    }
                });
            });
        },
        trackPageview: function (properties, timestamp, sourceInfo, userInfo) {
            timestamp !== null && timestamp !== void 0 ? timestamp : (timestamp = new Date());
            var sanitizedProperties = (0, sanitize_1.sanitizePageviewProperties)(properties, logger, logSource);
            if (!sanitizedProperties) {
                logger.warn('trackPageview failed because properties could not be converted to an object.', logSource);
                return Promise.resolve(null);
            }
            var sanitizedSourceInfo = (0, sanitize_1.sanitizeSourceInfo)(sourceInfo, logger, logSource) || sanitizedDefaultSource;
            var javascriptEpochTimestamp = (0, sanitize_1.sanitizeTimestamp)(timestamp, logger, logSource);
            // Build the event.
            var args = { properties: sanitizedProperties };
            if (javascriptEpochTimestamp) {
                args.javascriptEpochTimestamp = javascriptEpochTimestamp;
            }
            if (sanitizedSourceInfo) {
                args.sourceLibrary = sanitizedSourceInfo;
            }
            args.deadKeys = (0, pageviews_1.getDeadKeys)();
            function invokeTrackPageview(args, properties, userInfo) {
                return __awaiter(this, void 0, void 0, function () {
                    var result, pageviewKey, sessionId, removedKeys;
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0: return [4 /*yield*/, handleInvocation('trackPageview', args)];
                            case 1:
                                result = _a.sent();
                                if (!result) {
                                    return [2 /*return*/, null];
                                }
                                pageviewKey = result.pageviewKey;
                                sessionId = result.sessionId;
                                removedKeys = result.removedKeys;
                                if (Array.isArray(removedKeys)) {
                                    (0, pageviews_1.removeDeadKeys)(removedKeys);
                                }
                                if (typeof pageviewKey !== 'string' || typeof sessionId !== 'string') {
                                    return [2 /*return*/, null];
                                }
                                return [2 /*return*/, {
                                        pageviewKey: pageviewKey,
                                        sessionId: sessionId,
                                        properties: properties,
                                        userInfo: userInfo,
                                        sourceInfo: sourceInfo,
                                    }];
                        }
                    });
                });
            }
            var pageviewPromise = invokeTrackPageview(args, properties, userInfo);
            (0, pageviews_1.setLastPageview)(pageviewPromise);
            return pageviewPromise;
        },
    };
};
exports.createAutocaptureMethods = createAutocaptureMethods;
