"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.createBridgeInvocationHandler = void 0;
var extract_1 = require("./extract");
function resultForInvocation(promise, invocation) {
    return __awaiter(this, void 0, void 0, function () {
        var callbackId, data, error, e_1;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    callbackId = invocation.callbackId;
                    _a.label = 1;
                case 1:
                    _a.trys.push([1, 3, , 4]);
                    return [4 /*yield*/, promise];
                case 2:
                    data = _a.sent();
                    return [3 /*break*/, 4];
                case 3:
                    e_1 = _a.sent();
                    if (e_1 instanceof Error) {
                        error = e_1.message;
                    }
                    else if (e_1) {
                        error = e_1.toString();
                    }
                    else {
                        error = 'An unknown error occurred.';
                    }
                    return [3 /*break*/, 4];
                case 4:
                    if (!callbackId) {
                        return [2 /*return*/, null];
                    }
                    return [2 /*return*/, {
                            type: 'result',
                            callbackId: callbackId,
                            data: data,
                            error: error,
                        }];
            }
        });
    });
}
var createBridgeInvocationHandler = function (sourceManager, logger) {
    var handler = function (method, args) { return __awaiter(void 0, void 0, void 0, function () {
        var _a, sessionId, timestamp, foregrounded, timestamp, timestamp, pageviewKey, sessionId, timestamp, pageview, logLevel, message, source;
        var _b, _c, _d, _e, _f, _g, _h;
        return __generator(this, function (_j) {
            switch (_j.label) {
                case 0:
                    _a = method;
                    switch (_a) {
                        case 'didStartRecording': return [3 /*break*/, 1];
                        case 'didStopRecording': return [3 /*break*/, 2];
                        case 'sessionDidStart': return [3 /*break*/, 3];
                        case 'applicationDidEnterForeground': return [3 /*break*/, 4];
                        case 'applicationDidEnterBackground': return [3 /*break*/, 5];
                        case 'reissuePageview': return [3 /*break*/, 6];
                        case 'heapLogger_log': return [3 /*break*/, 8];
                    }
                    return [3 /*break*/, 9];
                case 1:
                    {
                        return [2 /*return*/, sourceManager.onStartRecording((0, extract_1.extractOptions)(args))];
                    }
                    _j.label = 2;
                case 2: return [2 /*return*/, sourceManager.onStopRecording()];
                case 3:
                    {
                        sessionId = (0, extract_1.extractString)(args, 'sessionId');
                        timestamp = (_b = (0, extract_1.extractTimestamp)(args)) !== null && _b !== void 0 ? _b : new Date();
                        foregrounded = (_c = (0, extract_1.extractBoolean)(args, 'foregrounded')) !== null && _c !== void 0 ? _c : false;
                        if (sessionId !== null) {
                            return [2 /*return*/, sourceManager.onSessionStart(sessionId, timestamp, foregrounded)];
                        }
                        else {
                            return [2 /*return*/, Promise.reject('sessionDidStart was called with invalid parameters.')];
                        }
                    }
                    _j.label = 4;
                case 4:
                    {
                        timestamp = (_d = (0, extract_1.extractTimestamp)(args)) !== null && _d !== void 0 ? _d : new Date();
                        return [2 /*return*/, sourceManager.onApplicationForegrounded(timestamp)];
                    }
                    _j.label = 5;
                case 5:
                    {
                        timestamp = (_e = (0, extract_1.extractTimestamp)(args)) !== null && _e !== void 0 ? _e : new Date();
                        return [2 /*return*/, sourceManager.onApplicationBackgrounded(timestamp)];
                    }
                    _j.label = 6;
                case 6:
                    pageviewKey = (0, extract_1.extractString)(args, 'pageviewKey');
                    sessionId = (0, extract_1.extractString)(args, 'sessionId');
                    timestamp = (_f = (0, extract_1.extractTimestamp)(args)) !== null && _f !== void 0 ? _f : new Date();
                    if (!pageviewKey || !sessionId) {
                        return [2 /*return*/, Promise.reject('reissuePageview was called with invalid parameters.')];
                    }
                    return [4 /*yield*/, sourceManager.reissuePageviewWithKey(pageviewKey, sessionId, timestamp)];
                case 7:
                    pageview = _j.sent();
                    return [2 /*return*/, (_g = pageview === null || pageview === void 0 ? void 0 : pageview.pageviewKey) !== null && _g !== void 0 ? _g : null];
                case 8:
                    {
                        logLevel = (0, extract_1.extractString)(args, 'logLevel');
                        message = (0, extract_1.extractString)(args, 'message');
                        source = (0, extract_1.extractString)(args, 'source');
                        if (message && logLevel) {
                            (_h = logger.getLogChannel()) === null || _h === void 0 ? void 0 : _h(logLevel, message, source);
                        }
                        return [2 /*return*/, Promise.resolve()];
                    }
                    _j.label = 9;
                case 9: return [2 /*return*/, Promise.reject("Unknown method ".concat(method, "."))];
            }
        });
    }); };
    return function (invocation) {
        var _a;
        var result = handler(invocation.method, (_a = invocation.arguments) !== null && _a !== void 0 ? _a : {});
        return resultForInvocation(result, invocation);
    };
};
exports.createBridgeInvocationHandler = createBridgeInvocationHandler;
