"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.extractBoolean = exports.extractString = exports.extractOptions = exports.extractTimestamp = void 0;
function extractTimestamp(args, argumentName) {
    if (argumentName === void 0) { argumentName = 'javascriptEpochTimestamp'; }
    var value = args[argumentName];
    if (typeof value === 'number') {
        return new Date(value);
    }
    else {
        return null;
    }
}
exports.extractTimestamp = extractTimestamp;
function extractOptions(args, argumentName) {
    if (argumentName === void 0) { argumentName = 'options'; }
    var value = args[argumentName];
    if (typeof value === 'object') {
        return __assign({}, value);
    }
    else {
        return {};
    }
}
exports.extractOptions = extractOptions;
function extractString(args, argumentName) {
    var value = args[argumentName];
    if (typeof value === 'string') {
        return value;
    }
    else {
        return null;
    }
}
exports.extractString = extractString;
function extractBoolean(args, argumentName) {
    var value = args[argumentName];
    if (typeof value === 'boolean') {
        return value;
    }
    else {
        return null;
    }
}
exports.extractBoolean = extractBoolean;
