"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.createPageviewKeyResolver = exports.waitForRecentResolutionsToTimeout = exports.clearRecentPageviewResolutions = exports.setRecentPageviewResolutionTimeout = exports.recordRecentPageviewResolution = exports.getRecentResolutionForKey = exports.getLastPageview = exports.clearLastPageview = exports.setLastPageview = exports.getDeadKeys = exports.removeDeadKeys = exports.addDeadKey = void 0;
var sanitize_1 = require("./sanitize");
var deadKeys = [];
// @ts-ignore
var deadKeyRegistry = global.FinalizationRegistry ? new FinalizationRegistry(addDeadKey) : null;
function addDeadKey(pageviewKey) {
    deadKeys.push(pageviewKey);
}
exports.addDeadKey = addDeadKey;
function removeDeadKeys(removedKeys) {
    if (!Array.isArray(removedKeys)) {
        return;
    }
    var removedSet = new Set(removedKeys);
    deadKeys = deadKeys.filter(function (pageviewKey) { return !removedSet.has(pageviewKey); });
}
exports.removeDeadKeys = removeDeadKeys;
function getDeadKeys() {
    return __spreadArray([], __read(deadKeys), false);
}
exports.getDeadKeys = getDeadKeys;
var lastPageviewPromise = Promise.resolve(null);
/**
 * Adds a pageview to the known key registry.
 *
 * When the pageview is garbage collected, its key is put in `getDeadKeys` so it can be cleaned up on the native layer.
 * @param promise A promise resolving to a pageview or null.
 */
function addKnownPageview(promise) {
    return __awaiter(this, void 0, void 0, function () {
        var pageview, error_1;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    _a.trys.push([0, 2, , 3]);
                    return [4 /*yield*/, promise];
                case 1:
                    pageview = _a.sent();
                    if (pageview && deadKeyRegistry) {
                        deadKeyRegistry.register(pageview, pageview === null || pageview === void 0 ? void 0 : pageview.pageviewKey);
                    }
                    return [3 /*break*/, 3];
                case 2:
                    error_1 = _a.sent();
                    return [3 /*break*/, 3];
                case 3: return [2 /*return*/];
            }
        });
    });
}
/**
 * Sets the last pageview to the results of resolution and adds the pageview to the known key registry.
 *
 * @param promise A promise resolving to a pageview or null.
 */
function setLastPageview(promise) {
    var _this = this;
    var wrap = function () { return __awaiter(_this, void 0, void 0, function () {
        var e_1;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    _a.trys.push([0, 2, , 3]);
                    return [4 /*yield*/, promise];
                case 1: return [2 /*return*/, _a.sent()];
                case 2:
                    e_1 = _a.sent();
                    return [2 /*return*/, null];
                case 3: return [2 /*return*/];
            }
        });
    }); };
    lastPageviewPromise = wrap();
    addKnownPageview(promise);
}
exports.setLastPageview = setLastPageview;
function clearLastPageview() {
    lastPageviewPromise = Promise.resolve(null);
}
exports.clearLastPageview = clearLastPageview;
function getLastPageview() {
    return lastPageviewPromise;
}
exports.getLastPageview = getLastPageview;
/**
 * A list of recently resolved pageviews, returned by the pageview resolver.  This is used for processing
 * `reissuePageview` when called from the native layer while not requiring the bridge to retain pageviews
 * indefinitely.
 *
 * The remaining three parameters support testing.
 */
var recentPageviewResolutions = [];
/**
 * The timeout for removing pageviews from `recentPageviewResolutions`.
 */
var recentPageviewResolutionTimeout = 5000;
/**
 * Gets a recently resolved pageview if it exists.
 * @param pageviewKey
 * @returns The most recent matching pageview, or null.
 */
var getRecentResolutionForKey = function (pageviewKey) {
    var _a;
    var reversedList = __spreadArray([], __read(recentPageviewResolutions), false).reverse();
    return ((_a = reversedList.find(function (_a) {
        var _b = __read(_a, 1), resolved = _b[0];
        return resolved.pageviewKey === pageviewKey;
    })) === null || _a === void 0 ? void 0 : _a[0]) || null;
};
exports.getRecentResolutionForKey = getRecentResolutionForKey;
/**
 * Adds a pageview to the recent resolution list and schedules its removal after a few seconds.
 *
 * @param pageview The pageview to add
 */
var recordRecentPageviewResolution = function (pageview) {
    if (recentPageviewResolutionTimeout <= 0) {
        return;
    }
    // This promise exists for testing.
    var resolve;
    var promise = new Promise(function (r) {
        resolve = r;
    });
    var resolvePromise = function () { return resolve === null || resolve === void 0 ? void 0 : resolve(); };
    // The timeout key also exists for testing.
    var timeout = global.setTimeout(function () {
        var index = recentPageviewResolutions.findIndex(function (_a) {
            var _b = __read(_a, 2), id = _b[1];
            return id === timeout;
        });
        if (index >= 0) {
            recentPageviewResolutions.splice(index, 1);
        }
        resolvePromise();
    }, recentPageviewResolutionTimeout);
    recentPageviewResolutions.push([pageview, timeout, promise, resolvePromise]);
};
exports.recordRecentPageviewResolution = recordRecentPageviewResolution;
/**
 * Sets the timeout resolution.
 *
 * This is used in testing since the default timeout is fairly high.
 *
 * @param timeout The number of milliseconds before pageviews are removed from the list.
 */
var setRecentPageviewResolutionTimeout = function (timeout) {
    recentPageviewResolutionTimeout = timeout;
};
exports.setRecentPageviewResolutionTimeout = setRecentPageviewResolutionTimeout;
/**
 * Clears all recently pageview resolutions.
 *
 * This is for use in `afterEach` so tests don't persist state and so timeouts can be resolved before jest exits.
 */
var clearRecentPageviewResolutions = function () {
    var e_2, _a;
    try {
        for (var recentPageviewResolutions_1 = __values(recentPageviewResolutions), recentPageviewResolutions_1_1 = recentPageviewResolutions_1.next(); !recentPageviewResolutions_1_1.done; recentPageviewResolutions_1_1 = recentPageviewResolutions_1.next()) {
            var _b = __read(recentPageviewResolutions_1_1.value, 4), id = _b[1], resolvePromise = _b[3];
            global.clearTimeout(id);
            resolvePromise();
        }
    }
    catch (e_2_1) { e_2 = { error: e_2_1 }; }
    finally {
        try {
            if (recentPageviewResolutions_1_1 && !recentPageviewResolutions_1_1.done && (_a = recentPageviewResolutions_1.return)) _a.call(recentPageviewResolutions_1);
        }
        finally { if (e_2) throw e_2.error; }
    }
    recentPageviewResolutions.length = 0;
};
exports.clearRecentPageviewResolutions = clearRecentPageviewResolutions;
/**
 * Waits for all currently resolved pageviews to be removed from the list.
 * @returns A promise that resolves when the pageviews are removed.
 */
var waitForRecentResolutionsToTimeout = function () {
    return Promise.all(recentPageviewResolutions.map(function (_a) {
        var _b = __read(_a, 3), promise = _b[2];
        return promise;
    }));
};
exports.waitForRecentResolutionsToTimeout = waitForRecentResolutionsToTimeout;
function isPromise(pageview) {
    // @ts-ignore
    return !!pageview && typeof pageview.then === 'function';
}
var pageviewIsValid = function (pageview) {
    return (0, sanitize_1.isNonEmptyString)(pageview === null || pageview === void 0 ? void 0 : pageview.pageviewKey);
};
/**
 * Creates a function that can resolve a pageview for a given interaction.
 */
var createPageviewKeyResolver = function (sourceManager, logger, logSource) {
    return function (pageview, source, timestamp) { return __awaiter(void 0, void 0, void 0, function () {
        var error_2;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    if (pageview === 'none') {
                        return [2 /*return*/, 'none'];
                    }
                    if (!isPromise(pageview)) return [3 /*break*/, 4];
                    _a.label = 1;
                case 1:
                    _a.trys.push([1, 3, , 4]);
                    return [4 /*yield*/, pageview];
                case 2:
                    pageview = _a.sent();
                    return [3 /*break*/, 4];
                case 3:
                    error_2 = _a.sent();
                    pageview = null;
                    logger.debug('Pageview threw an error and will be ignored.', logSource);
                    logger.trace("Pageview error: ".concat(error_2), logSource);
                    return [3 /*break*/, 4];
                case 4:
                    if (pageview && !pageviewIsValid(pageview)) {
                        pageview = null;
                        logger.debug('Pageview did not have a valid key and will be ignored.', logSource);
                    }
                    if (!(sourceManager === null || sourceManager === void 0 ? void 0 : sourceManager.pageviewNeedsReissue(pageview))) return [3 /*break*/, 6];
                    return [4 /*yield*/, sourceManager.reissuePageview(pageview, null, timestamp)];
                case 5:
                    pageview = _a.sent();
                    _a.label = 6;
                case 6:
                    if (!!pageviewIsValid(pageview)) return [3 /*break*/, 8];
                    return [4 /*yield*/, (sourceManager === null || sourceManager === void 0 ? void 0 : sourceManager.activePageview(source === null || source === void 0 ? void 0 : source.name, timestamp))];
                case 7:
                    pageview = _a.sent();
                    _a.label = 8;
                case 8:
                    if (!!pageviewIsValid(pageview)) return [3 /*break*/, 10];
                    return [4 /*yield*/, lastPageviewPromise];
                case 9:
                    pageview = _a.sent();
                    _a.label = 10;
                case 10:
                    if (!pageviewIsValid(pageview)) {
                        return [2 /*return*/, null];
                    }
                    (0, exports.recordRecentPageviewResolution)(pageview);
                    return [2 /*return*/, pageview.pageviewKey];
            }
        });
    }); };
};
exports.createPageviewKeyResolver = createPageviewKeyResolver;
