import { Options, Pageview, Source } from '../types';
export declare class CountingSource implements Source {
    readonly calls: Array<['onStartRecording', Options] | 'onStopRecording' | ['onSessionStart', string, Date, boolean] | ['onApplicationForegrounded', Date] | ['onApplicationBackgrounded', Date] | ['reissuePageview', Pageview, string | null, Date] | ['activePageview', string | null, Date]>;
    readonly name: string;
    readonly version: string;
    constructor(name?: string, version?: string);
    returnsPageviews: boolean;
    clear(): void;
    reset(): void;
    onStartRecording(options: Options): Promise<void>;
    onStopRecording(): Promise<void>;
    onSessionStart(sessionId: string, timestamp: Date, foregrounded: boolean): Promise<void>;
    onApplicationForegrounded(timestamp: Date): Promise<void>;
    onApplicationBackgrounded(timestamp: Date): Promise<void>;
    reissuePageview(pageview: Pageview, sessionId: string | null, timestamp: Date): Promise<null> | Promise<{
        pageviewKey: string;
        sessionId: string;
        properties: {};
        sourceInfo: {
            name: string;
            version: string;
            platform: string;
        };
    }>;
    activePageview(sessionId: string | null, timestamp: Date): Promise<{
        pageviewKey: string;
        sessionId: string;
        properties: {};
        sourceInfo: {
            name: string;
            version: string;
            platform: string;
        };
    }> | Promise<null>;
}
export declare class ThrowingSource implements Source {
    readonly name: string;
    readonly version: string;
    constructor(name?: string, version?: string);
    onStartRecording(options: Options): Promise<void>;
    onStopRecording(): Promise<void>;
    onSessionStart(sessionId: string, timestamp: Date, foregrounded: boolean): Promise<void>;
    onApplicationForegrounded(timestamp: Date): Promise<void>;
    onApplicationBackgrounded(timestamp: Date): Promise<void>;
    reissuePageview(pageview: Pageview, sessionId: string | null, timestamp: Date): Promise<null>;
    activePageview(sessionId: string | null, timestamp: Date): Promise<null>;
}
