import type { InvocationHandler } from '../bridge';
export declare enum LogLevel {
    None = "none",
    Error = "error",
    Warn = "warn",
    Info = "info",
    Debug = "debug",
    Trace = "trace"
}
export type LogChannel = (logLevel: LogLevel, message: string, source: string | null | undefined) => void;
/**
 * DO NOT USE
 * This class is an internal implementation detail of the SDK and should NOT be used
 * directly by developers implementing the SDK. It is public for internal purposes only.
 *
 * Please refer to the SDK documentation for the appropriate public classes and methods
 * to use when integrating the SDK into your project.
 */
export interface HeapLogger {
    error(message: string, source?: string): void;
    warn(message: string, source?: string): void;
    info(message: string, source?: string): void;
    debug(message: string, source?: string): void;
    trace(message: string, source?: string): void;
    setLogLevel(logLevel: LogLevel): void;
    getLogLevel(): Promise<LogLevel>;
    setLogChannel(logChannel: LogChannel | null): void;
    getLogChannel(): LogChannel | null;
}
export declare const createLogger: (handleInvocation: InvocationHandler) => HeapLogger;
export declare const HeapConsoleLogChannel: LogChannel;
